<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Home extends MX_Controller 
{
	public function __construct() 
	{
		parent::__construct();
		$this->load->helper('cookie');
	}
	
	public function index ()
	{         
		$admin_info = $this->session->userdata('adminInfo');
		if ($admin_info)
		{
			$data['statistics'] = $this->getStatistics();
            $data['content']="";
            $this->load->view('home/index', $data);
		}else
		{
			$this->load->view ( 'login');
		}
	}
         public function getStatistics() {
        $data = array();

        $last_month['start'] = strtotime(date("Y-m-d", strtotime("first day of previous month")) . " 00:00:00");
        $last_month['end'] = strtotime(date("Y-m-d", strtotime("last day of previous month")) . " 23:59:59");

        $last_week['start'] = strtotime(date("Y-m-d", strtotime("first day of previous week")) . " 00:00:00");
        $last_week['end'] = strtotime(date("Y-m-d", strtotime("last day of previous week")) . " 23:59:59");

        $last_week['end'] = strtotime('last sunday') + (24 * 60 * 60 - 1);
        $last_week['start'] = ($last_week['end'] - 7 * 24 * 60 * 60 + 1);

        $last_year['start'] = strtotime((date("Y") - 1) . "-01-01 00:00:00");
        $last_year['end'] = strtotime((date("Y") - 1) . "-12-31 23:59:59");



        $last_quarter = $this->getLastquarter();
        $last_quarter['start'] = $last_quarter['start'];
        $last_quarter['end'] = $last_quarter['end'];


        $this->load->model('paidlog_model');
        $paidlogs = $this->paidlog_model->getAllPaidlogs($last_year['start']);

        $revenue['last_week'] = 0;
        $revenue['last_month'] = 0;
        $revenue['last_quarter'] = 0;
        $revenue['last_year'] = 0;

        $lastmonth = strtotime("first day of previous month");
        $thismonth = strtotime("first day of this month");
        $charts['last_month'] = array(0 => 0, 1 => 0, 2 => 0, 3 => 0, 4 => 0);
        $charts['this_month'] = array(0 => 0, 1 => 0, 2 => 0, 3 => 0, 4 => 0);
        
        $top['last_month']['user']=0;
        $top['last_month']['sms']=0;
        $top['last_month']['card']=0;
        $top['last_month']['collaborator']=0;
        $top['this_month']['user']=0;
        $top['this_month']['sms']=0;
        $top['this_month']['card']=0;
        $top['this_month']['collaborator']=0;
        foreach ($paidlogs as $paidlog) {

            
            if (($paidlog['time'] < $last_week['end']) && ($paidlog['time'] > $last_week['start'])) {
                $revenue['last_week']+=$paidlog['amount'];
            }
            if (($paidlog['time'] < $last_month['end']) && ($paidlog['time'] > $last_month['start'])) {
                $revenue['last_month']+=$paidlog['amount'];
            }
            if (($paidlog['time'] < $last_quarter['end']) && ($paidlog['time'] > $last_quarter['start'])) {
                $revenue['last_quarter']+=$paidlog['amount'];
            }
            if (($paidlog['time'] < $last_year['end']) && ($paidlog['time'] > $last_year['start'])) {
                $revenue['last_year']+=$paidlog['amount'];
            }
           
            
            if (($paidlog['time'] < $lastmonth + (7 * 24 * 60 * 60)) && ($paidlog['time'] > $lastmonth)) {
                $charts['last_month'][0]+=$paidlog['amount'];
            }
            if (($paidlog['time'] < $lastmonth + (14 * 24 * 60 * 60)) && ($paidlog['time'] > $lastmonth + (7 * 24 * 60 * 60))) {
                $charts['last_month'][1]+=$paidlog['amount'];
            }
            if (($paidlog['time'] < $lastmonth + (21 * 24 * 60 * 60)) && ($paidlog['time'] > $lastmonth + (14 * 24 * 60 * 60))) {
                $charts['last_month'][2]+=$paidlog['amount'];
            }
            if (($paidlog['time'] < $lastmonth + (28 * 24 * 60 * 60)) && ($paidlog['time'] > $lastmonth + (21 * 24 * 60 * 60))) {
                $charts['last_month'][3]+=$paidlog['amount'];
            }
            if (($paidlog['time'] < $thismonth) && ($paidlog['time'] > $lastmonth + (28 * 24 * 60 * 60))) {
                $charts['last_month'][4]+=$paidlog['amount'];
            }
            
            if (($paidlog['time'] < $thismonth) && ($paidlog['time'] > $lastmonth)) {
                $top['last_month']['user']++;
                if ($paidlog['paid_type']==1)
                {
                   $top['last_month']['sms']+=$paidlog['amount']; 
                }
                if ($paidlog['paid_type']==2)
                {
                    $top['last_month']['card']+=$paidlog['amount'];
                }
                if ($paidlog['collaborator']!="")
                {
                    $top['last_month']['collaborator']+=$paidlog['amount'];
                }
            }
            
            

            if (($paidlog['time'] < $thismonth + (7 * 24 * 60 * 60)) && ($paidlog['time'] > $thismonth)) {
                $charts['this_month'][0]+=$paidlog['amount'];
            }
            if (($paidlog['time'] < $thismonth + (14 * 24 * 60 * 60)) && ($paidlog['time'] > $thismonth + (7 * 24 * 60 * 60))) {
                $charts['this_month'][1]+=$paidlog['amount'];
            }
            if (($paidlog['time'] < $thismonth + (21 * 24 * 60 * 60)) && ($paidlog['time'] > $thismonth + (14 * 24 * 60 * 60))) {
                $charts['this_month'][2]+=$paidlog['amount'];
            }
            if (($paidlog['time'] < $thismonth + (28 * 24 * 60 * 60)) && ($paidlog['time'] > $thismonth + (21 * 24 * 60 * 60))) {
                $charts['this_month'][3]+=$paidlog['amount'];
            }
            if (($paidlog['time'] < $thismonth + (31 * 24 * 60 * 60)) && ($paidlog['time'] > $thismonth + (28 * 24 * 60 * 60))) {
                $charts['this_month'][4]+=$paidlog['amount'];
            }
            if (($paidlog['time'] < $thismonth + (31 * 24 * 60 * 60)) && ($paidlog['time'] > $thismonth )) {
                $top['this_month']['user']++;
                if ($paidlog['paid_type']==1)
                {
                   $top['this_month']['sms']+=$paidlog['amount']; 
                }
                if ($paidlog['paid_type']==2)
                {
                    $top['this_month']['card']+=$paidlog['amount'];
                }
                if ($paidlog['collaborator']!="")
                {
                    $top['this_month']['collaborator']+=$paidlog['amount'];
                }
            }
        }
        $percent=array();
        foreach ($top['this_month'] as $index=>$value)
        {
            $percent[$index]['class']="down";
            $percent[$index]['display']="giảm";
            $percent[$index]['value']="n/a";
            if (($top['this_month'][$index]>0)&&($top['last_month'][$index]>0))
            {
            $percent[$index]['value']=round((($top['this_month'][$index] / $top['last_month'][$index])*100),1);
            if ($top['this_month'][$index] > $top['last_month'][$index])
            {
               $percent[$index]['class']="up"; 
               $percent[$index]['display']="tăng";
            }
            }
        }
        $data['percent']=$percent;
        $data['top']=$top;
        $max = 0;
        foreach ($charts['last_month'] as $index => $total) {
            if ($total > $max) {
                $max = $total;
            }
            $chart_last_month[] = array($index, $total);
        }
        foreach ($charts['this_month'] as $index => $total) {
            if ($total > $max) {
                $max = $total;
            }
            $chart_this_month[] = array($index, $total);
        }

        $data['revenue'] = $revenue;
        $data['max'] = $max;
        $chard[] = array("color" => "#e67e22", "label" => "Tháng hiện tại", "data" => $chart_this_month);
        $chard[] = array("color" => "#1abc9c", "label" => "Tháng trước", "data" => $chart_last_month);

        $data['chard'] = $chard;

        return $this->load->view('home/statistics', $data, true);
    }
    public function getLastquarter() {
        $current_month = date('m');
        $current_year = date('Y');

        if ($current_month >= 1 && $current_month <= 3) {
            $start_date = strtotime('1-October-' . ($current_year - 1));  // timestamp or 1-October Last Year 12:00:00 AM
            $end_date = strtotime('1-Janauary-' . $current_year);  // // timestamp or 1-January  12:00:00 AM means end of 31 December Last year
        } else if ($current_month >= 4 && $current_month <= 6) {
            $start_date = strtotime('1-January-' . $current_year);  // timestamp or 1-Janauray 12:00:00 AM
            $end_date = strtotime('1-April-' . $current_year);  // timestamp or 1-April 12:00:00 AM means end of 31 March
        } else if ($current_month >= 7 && $current_month <= 9) {
            $start_date = strtotime('1-April-' . $current_year);  // timestamp or 1-April 12:00:00 AM
            $end_date = strtotime('1-July-' . $current_year);  // timestamp or 1-July 12:00:00 AM means end of 30 June
        } else if ($current_month >= 10 && $current_month <= 12) {
            $start_date = strtotime('1-July-' . $current_year);  // timestamp or 1-July 12:00:00 AM
            $end_date = strtotime('1-October-' . $current_year);  // timestamp or 1-October 12:00:00 AM means end of 30 September
        }
        return array("start" => $start_date, "end" => $end_date);
    }

	
	public function login()
	{
           
		$login_name = $this->input->post('login_name');
		$passwd = $this->input->post('passwd');
		
		$this->load->model(array('admin_model'));
		$data = $this->admin_model->check_login($login_name, $passwd);
		if ($data == null)
		{
			$this->session->set_flashdata('login_error', TRUE);
			redirect("/admin/home");
		}
		else
		{
			$admindata = array('login_name' => $login_name, 'admin_id'=>$data->admin_id, 'role_id'=>$data->role_id, 'logined_in' => TRUE);
			$this->session->set_userdata('adminInfo', $admindata);
			redirect("/admin/home");
		}
	}
	
	public function logout()
	{
		$this->session->sess_destroy();
		redirect("/admin/home");
	}
}